<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: MocoStudy: custom optimal control problems</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('mocostudy.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title"><a class="el" href="classOpenSim_1_1MocoStudy.html" title="The top-level class for solving a custom optimal control problem.">MocoStudy</a>: custom optimal control problems </div>  </div>
</div><!--header-->
<div class="contents">
<div class="toc"><h3>Table of Contents</h3>
<ul><li class="level1"><a href="#mocostudyoverview">Overview</a></li>
<li class="level1"><a href="#MocoProblem">MocoProblem</a><ul><li class="level2"><a href="#Bounds">Bounds</a><ul><li class="level3"><a href="#Time">Time</a></li>
<li class="level3"><a href="#Defaults">Defaults</a></li>
</ul>
</li>
<li class="level2"><a href="#costfunctional">Defining the cost functional and endpoint constraints</a></li>
<li class="level2"><a href="#params">Parameter optimization with MocoParameter</a></li>
<li class="level2"><a href="#preskin">Prescribed kinematics</a><ul><li class="level3"><a href="#preskinconstr">Prescribed kinematics with kinematic constraints</a></li>
</ul>
</li>
<li class="level2"><a href="#implicitauxiliary">Implicit auxiliary dynamics</a></li>
</ul>
</li>
<li class="level1"><a href="#MocoSolver">MocoSolver</a><ul><li class="level2"><a href="#implicitmultibody">Implicit multibody dynamics mode</a></li>
<li class="level2"><a href="#kincon">Kinematic constraints</a></li>
</ul>
</li>
<li class="level1"><a href="#casadivstropter">MocoCasADiSolver versus MocoTropterSolver</a></li>
<li class="level1"><a href="#tips">Tips for solving a custom problem</a></li>
<li class="level1"><a href="#mocostudyrefs">References</a></li>
</ul>
</div>
<div class="textblock"><p><a class="el" href="classOpenSim_1_1MocoStudy.html" title="The top-level class for solving a custom optimal control problem.">MocoStudy</a> allows one to solve a generic optimal control problem, where the costs, constraints, and solver settings are fully defined by the user.</p>
<p>Solving a custom optimal control problem with direct collocation requires substantial tuning of the direct collocation method's settings. Use the more specific interfaces <a class="el" href="classOpenSim_1_1MocoInverse.html" title="This tool solves problems in which the kinematics are prescribed and you seek the actuator (e....">MocoInverse</a> and <a class="el" href="classOpenSim_1_1MocoTrack.html">MocoTrack</a> if possible.</p>
<p>For a mathematical description, see <a class="el" href="mocotheoryguide.html#mocoocp">Optimal control problem</a>.</p>
<p>In Moco, "goals", such as tracking marker data or effort, can be enforced either as cost terms to minimize or endpoint constraints.</p>
<h1><a class="anchor" id="mocostudyoverview"></a>
Overview</h1>
<p>A <a class="el" href="classOpenSim_1_1MocoStudy.html" title="The top-level class for solving a custom optimal control problem.">MocoStudy</a> contains a <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a> and a <a class="el" href="classOpenSim_1_1MocoSolver.html" title="Once the solver is created, you should not make any edits to the MocoProblem.">MocoSolver</a>.</p>
<ul>
<li><a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a>: describes the variables, dynamics, constraints, and cost functional of the optimal control problem, using an <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> model.</li>
<li><a class="el" href="classOpenSim_1_1MocoSolver.html" title="Once the solver is created, you should not make any edits to the MocoProblem.">MocoSolver</a>: solves the <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a> using direct collocation.</li>
</ul>
<p>When building a <a class="el" href="classOpenSim_1_1MocoStudy.html" title="The top-level class for solving a custom optimal control problem.">MocoStudy</a> programmatically (e.g., in C++), the workflow is as follows:</p>
<ol type="1">
<li>Build the <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a> (set the model, constraints, etc.).</li>
<li>Call MocoStudy::initTropterSolver() or MocoStudy::initCasADiSolver(), which returns a reference to a <a class="el" href="classOpenSim_1_1MocoSolver.html" title="Once the solver is created, you should not make any edits to the MocoProblem.">MocoSolver</a>.</li>
<li>Edit the settings of the <a class="el" href="classOpenSim_1_1MocoSolver.html" title="Once the solver is created, you should not make any edits to the MocoProblem.">MocoSolver</a>.</li>
<li>Call MocoStudy::solve(). This returns the <a class="el" href="classOpenSim_1_1MocoSolution.html" title="Return type for MocoStudy::solve().">MocoSolution</a>.</li>
<li>(Optional) Postprocess the solution, perhaps using MocoStudy::visualize().</li>
</ol>
<p>After calling MocoStudy::solve(), you can edit the <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a> and/or the <a class="el" href="classOpenSim_1_1MocoSolver.html" title="Once the solver is created, you should not make any edits to the MocoProblem.">MocoSolver</a> and call MocoStudy::solve() again, if you wish.</p>
<h1><a class="anchor" id="MocoProblem"></a>
MocoProblem</h1>
<p>A <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a> is a list of <a class="el" href="classOpenSim_1_1MocoPhase.html" title="The states, controls, dynamics, parameters, goals, and constraints for a phase of the problem.">MocoPhase</a>s, but Moco currently supports only single-phase problems. A <a class="el" href="classOpenSim_1_1MocoPhase.html" title="The states, controls, dynamics, parameters, goals, and constraints for a phase of the problem.">MocoPhase</a> consists of the following:</p>
<ol type="1">
<li>An <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> model that describes states, controls, dynamics, and kinematic constraints.</li>
<li><a class="el" href="classOpenSim_1_1MocoGoal.html" title="A goal is a term in the cost functional to be minimized, or a set of endpoint constraints that must l...">MocoGoal</a>s: describes the cost functional to minimize or endpoint constraints to enforce.</li>
<li><a class="el" href="classOpenSim_1_1MocoPathConstraint.html" title="A path constraint to be enforced in the optimal control problem.">MocoPathConstraint</a>s: describes non-kinematic algebraic constraints to enforce over the entire phase.</li>
<li><a class="el" href="classOpenSim_1_1MocoParameter.html" title="A MocoParameter allows you to optimize property values in an OpenSim Model.">MocoParameter</a>s: describes <a class="el" href="classOpenSim_1_1Model.html" title="A concrete class that specifies the interface to a musculoskeletal model.">Model</a> (time-invariant) properties to optimize.</li>
<li>Bounds on initial and final time.</li>
<li>Bounds (initial, final, and over all time) for state variables, stored in <a class="el" href="classOpenSim_1_1MocoVariableInfo.html" title="Bounds on continuous variables (states, controls, multipliers, etc).">MocoVariableInfo</a>.</li>
<li>Bounds (initial, final, and over all time) for control variables, stored in <a class="el" href="classOpenSim_1_1MocoVariableInfo.html" title="Bounds on continuous variables (states, controls, multipliers, etc).">MocoVariableInfo</a>.</li>
</ol>
<h2><a class="anchor" id="Bounds"></a>
Bounds</h2>
<h3><a class="anchor" id="Time"></a>
Time</h3>
<p>By default, the initial time and final time are unconstrained. However, this is rarely what you want, and often causes a problem to behave poorly. Moco issues a warning if you do not set bounds for initial or final time.</p>
<h3><a class="anchor" id="Defaults"></a>
Defaults</h3>
<p>Setting bounds for state and control variables is an important but often tedious process. To help, Moco sets some variable bounds automatically. See <a class="el" href="classOpenSim_1_1MocoPhase.html#accf1ef5619b90bda2ff39b2f9654d53e" title="Set information about a single state variable in this phase.">MocoPhase::setStateInfo()</a> and <a class="el" href="classOpenSim_1_1MocoPhase.html#aa7e632ef04d906ae6cf339bafa65f7e9" title="Set information about a single control variable in this phase.">MocoPhase::setControlInfo()</a> for details.</p>
<p>Although Moco supports setting initial and final bounds for controls, such functionality is not too useful: the initial and final values of a control have little influence on the value of the control at nearby times.</p>
<h2><a class="anchor" id="costfunctional"></a>
Defining the cost functional and endpoint constraints</h2>
<p>See <a class="el" href="group__mocogoal.html">Moco: Available goals</a> for more information.</p>
<h2><a class="anchor" id="params"></a>
Parameter optimization with MocoParameter</h2>
<p>Moco allows you to optimize most model parameters by adding a MocoParameter to your <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a>. See <a class="el" href="classOpenSim_1_1MocoParameter.html" title="A MocoParameter allows you to optimize property values in an OpenSim Model.">MocoParameter</a> for more information.</p>
<h2><a class="anchor" id="preskin"></a>
Prescribed kinematics</h2>
<p>You may wish to solve a problem in which you prescribe known kinematics for all degrees of freedom and optimize only auxiliary dynamics or actuator behavior. In this formulation, the generalized coordinate and speed variables are replaced with known quantities. The system still contains auxiliary state variables, control variables, and auxiliary dynamics. If none of the parameter variables affect the multibody system, then the multibody dynamics is reduced to a force balance: applied forces must match the net generalized forces determined by the kinematics (that is, inverse dynamics).</p>
<p>To prescribe motion in the "reduce-DOF" way, add a <a class="el" href="classOpenSim_1_1PositionMotion.html" title="This class prescribes the value, speed, and acceleration of all coordinates in the model using SimTK:...">PositionMotion</a> component to your model. <a class="el" href="classOpenSim_1_1PositionMotion.html" title="This class prescribes the value, speed, and acceleration of all coordinates in the model using SimTK:...">PositionMotion</a> requires that all DOFs are prescribed; Moco does not support prescribing a subset of the degrees of freedom.</p>
<p>See <a class="el" href="mocoinverse.html">MocoInverse: solving muscle and actuator redundancy</a> and <a class="el" href="mocodevguide.html#implpreskin">Prescribed kinematics</a> for more information.</p>
<h3><a class="anchor" id="preskinconstr"></a>
Prescribed kinematics with kinematic constraints</h3>
<p>Prescribing kinematics is more complicated if the system contains kinematic constraints (e.g., weld constraints, point-on-line constraints, etc.), as such constraints can conflict with the prescribed kinematics (which is also essentially a constraint).</p>
<dl class="section note"><dt>Note</dt><dd>If a model contains kinematic constraints, you must ensure that the prescribed motion obeys the kinematic constraints. <a class="el" href="classOpenSim_1_1PositionMotion.html" title="This class prescribes the value, speed, and acceleration of all coordinates in the model using SimTK:...">PositionMotion</a> does not ensure this for you. <a class="el" href="classOpenSim_1_1MocoInverse.html" title="This tool solves problems in which the kinematics are prescribed and you seek the actuator (e....">MocoInverse</a> attempts to alter your provided kinematics to satisfy the kinematic constraints (using Model::assemble()).</dd></dl>
<h2><a class="anchor" id="implicitauxiliary"></a>
Implicit auxiliary dynamics</h2>
<p><a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a>'s <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a>s support auxiliary dynamics, that is, additional dynamics added to the multibody dynamics equations that define a model's computational system (e.g., muscle activation dynamics). <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a>s support dynamics in explicit form (i.e., \( \dot{y} = f(y) \)), but it is often desirable to implement auxiliary dynamics in implicit form (i.e., \( f(y, \dot{y}) = 0 \)). For example, expressing tendon compliance dynamics explicitly requires inverting the force-velocity curve, which introduces singularities. Solving the dynamics implicitly by enforcing muscle-tendon equilibrium (i.e. \( F^T - F^M cos(\alpha) = 0 \)) is more natural and avoids such numerical issues [1].</p>
<p><a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a>'s numerical integrators only support explicit differential equations, but Moco allows <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a>s to express dynamics with implicit differential equations in addition to explicit differential equations. Currently, implicit differential equations are provided for the following pairs of components and state variables:</p>
<ul>
<li><a class="el" href="classOpenSim_1_1DeGrooteFregly2016Muscle.html" title="This muscle model was published in De Groote et al.">DeGrooteFregly2016Muscle</a>'s normalized_tendon_force.</li>
</ul>
<p>See the documentation for these components to learn how to set their dynamics mode.</p>
<p>Implicit differential equations require an additional control for the derivative of the state variable; MocoTrajectories associated with a model containing implicit auxiliary dynamics contain columns for these state variable derivatives.</p>
<p>To set the mode for multibody dynamics, see <a class="el" href="mocostudy.html#implicitmultibody">Implicit multibody dynamics mode</a>.</p>
<dl class="section note"><dt>Note</dt><dd><b>Implicit versus explicit integrators</b>: Differential equations can be implicit and explicit, but so can numerical integrators. This is often a point of confusion. Implicit and explicit numerical integrators describe types of methods for solving differential equations; both implicit and explicit numerical integrators can be used with explicit differential equations, while only implicit numerical integrators can be used with implicit differential equations.</dd></dl>
<p>To implement implicit auxiliary differential equations yourself, see <a class="el" href="exampleCustomImplicitAuxiliaryDynamics_8cpp-example.html">exampleCustomImplicitAuxiliaryDynamics.cpp</a>.</p>
<h1><a class="anchor" id="MocoSolver"></a>
MocoSolver</h1>
<p>A <a class="el" href="classOpenSim_1_1MocoSolver.html" title="Once the solver is created, you should not make any edits to the MocoProblem.">MocoSolver</a> attempts to use an optimal control method to solve the <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a>, and exposes settings you can use to control the transcription to a generic optimization problem and the optimization process.</p>
<h2><a class="anchor" id="implicitmultibody"></a>
Implicit multibody dynamics mode</h2>
<p>MocoSolvers support two modes for expressing differential equations for multibody dynamics. When using the implicit dynamics mode, the differential equations for multibody dynamics are expressed as implicit differential equations. See the descriptions for the specific transcription schemes for more detail. As with implicit auxiliary dynamics, using implicit multibody dynamics often leads to a more robust problem, especially for systems with small masses [2].</p>
<h2><a class="anchor" id="kincon"></a>
Kinematic constraints</h2>
<p>Moco supports enforcing <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> kinematic constraints in optimal control problems. When a solver is initialized, any kinematic constraints enabled in the model are automatically detected, and additional information about each constraint is stored. This information includes the number of scalar path constraints (including derivatives if they exist), the scalar constraint kinematic levels (i.e. holonomic, non-holonomic, or acceleration), and the number of Lagrange multipliers that are added to the problem to enforce the constraints.</p>
<p>The solvers allow the user to choose whether to enforce kinematic constraint derivatives or minimize Lagrange multipliers in the problem.</p>
<div class="fragment"><div class="line">MocoTropterSolver&amp; solver = moco.initTropterSolver();</div>
<div class="line">solver.set_enforce_constraint_derivatives(<span class="keyword">true</span>);</div>
<div class="line">solver.set_lagrange_multiplier_weight(10);</div>
</div><!-- fragment --><p>If constraint derivatives are enforced, velocity correction variables are added to the problem according to the method described in Posa, Kuindersma, and Tedrake, 2016, "Optimization and stabilization of trajectories for constrained
dynamical systems."</p>
<dl class="section note"><dt>Note</dt><dd>Enforcing kinematic constraints is only supported with Hermite-Simpson transcription, since this scheme is necessary for implementing the method described in Posa et al. 2016. See <a class="el" href="mocotheoryguide.html#mocohermitesimpsontheory">Hermite–Simpson transcription</a> for a mathematical description.</dd></dl>
<p>It is possible to modify the default bounds on these velocity correction variables:</p>
<div class="fragment"><div class="line"><span class="comment">// Default bounds: [-0.1, 0.1]</span></div>
<div class="line">solver.set_velocity_correction_bounds({-0.25, 0.25});</div>
</div><!-- fragment --><p>If constraint derivatives are not enforced or if the multibody constraint Jacobian is rank-deficient, it is recommended that the Lagrange multiplier minimization term is added to the problem to impose uniqueness for these variables.</p>
<p>Even though <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> Models can contain non-holonomic constraints (that is, \( \nu(q, u, p) = 0 \)), Moco solvers support only holonomic constraints; that is, \( \phi(q) = 0 \).</p>
<p>By default, the controls at mesh interval midpoints are constrained by linear interpolation of control mesh endpoint values and is the recommended setting. However, you may disable this behavior in the solver:</p>
<div class="fragment"><div class="line">MocoCasADiSolver&amp; solver = moco.initCasADiSolver();</div>
<div class="line">solver.set_interpolate_control_midpoints(<span class="keyword">false</span>);</div>
</div><!-- fragment --><h1><a class="anchor" id="casadivstropter"></a>
MocoCasADiSolver versus MocoTropterSolver</h1>
<p>Moco provides two direct collocation solvers that transcribe continuous optimal control problems into finite-dimensional NLPs that are passed to well-established derivative-based NLP solvers. <a class="el" href="classOpenSim_1_1MocoCasADiSolver.html" title="This solver uses the CasADi library (https://casadi.org) to convert the MocoProblem into a generic no...">MocoCasADiSolver</a> uses the third-party CasADi library, and <a class="el" href="classOpenSim_1_1MocoTropterSolver.html" title="Solve the MocoProblem using the tropter direct collocation library.">MocoTropterSolver</a> uses a direct collocation solver developed internally named Tropter. CasADi is an open-source package for algorithmic differentiation and is a bridge to NLP solvers IPOPT, SNOPT, and others.</p>
<p>Compared to <a class="el" href="classOpenSim_1_1MocoTropterSolver.html" title="Solve the MocoProblem using the tropter direct collocation library.">MocoTropterSolver</a>, <a class="el" href="classOpenSim_1_1MocoCasADiSolver.html" title="This solver uses the CasADi library (https://casadi.org) to convert the MocoProblem into a generic no...">MocoCasADiSolver</a> supports parallelization, implicit auxiliary dynamics, and implicit multibody dynamics with kinematic constraints. However, <a class="el" href="classOpenSim_1_1MocoTropterSolver.html" title="Solve the MocoProblem using the tropter direct collocation library.">MocoTropterSolver</a> may be able to solve parameter optimization problems more quickly that <a class="el" href="classOpenSim_1_1MocoCasADiSolver.html" title="This solver uses the CasADi library (https://casadi.org) to convert the MocoProblem into a generic no...">MocoCasADiSolver</a>.</p>
<p>CasADi is an ideal library for employing direct collocation, but two limitations led us to create Tropter: CasADi did not initially support finite differences, and CasADi’s open-source license is more restrictive than OpenSim’s. Those distributing Moco as a dependency of closed-source software may prefer distributing Moco without CasADi, as CasADi’s “weak copyleft” GNU Lesser General Public License 3.0 places requirements on how CasADi is redistributed.</p>
<h1><a class="anchor" id="tips"></a>
Tips for solving a custom problem</h1>
<ol type="1">
<li>Make sure every variable has bounds.</li>
<li>Create a dynamically-consistent initial guess by solving a feasibility problem. That is, solve a <a class="el" href="classOpenSim_1_1MocoStudy.html" title="The top-level class for solving a custom optimal control problem.">MocoStudy</a> without any cost terms.</li>
<li>Actuators should only be as strong as they need to be. Problems tend to converge slower if some actuator controls are very small compared to those of other actuators in the model due to unecessarily large max force settings.</li>
<li>Add reserve actuators to muscle-driven problems (whether inverse, tracking, predicdtive, etc.) to improve convergence and identify muscles that are too weak to drive a desired motion.</li>
<li>If controls display high frequency oscillations, try tightening the solver's convergence and constraint tolerances.</li>
</ol>
<h1><a class="anchor" id="mocostudyrefs"></a>
References</h1>
<p>[1] Groote, F., Kinney, A., Rao, A., Fregly, B. (2016). Evaluation of Direct Collocation Optimal <a class="el" href="classOpenSim_1_1Control.html" title="A class that represents a control in a dynamic simulation.">Control</a> Problem Formulations for Solving the <a class="el" href="classOpenSim_1_1Muscle.html" title="A base class for modeling a muscle-tendon actuator.">Muscle</a> Redundancy Problem Annals of Biomedical Engineering 44(10), 2922-2936. <a href="https://dx.doi.org/10.1007/s10439-016-1591-9">https://dx.doi.org/10.1007/s10439-016-1591-9</a></p>
<p>[2] Bogert, A., Blana, D., Heinrich, D. (2011). Implicit methods for efficient musculoskeletal simulation and optimal control Procedia IUTAM 2(), 297-316. <a href="https://dx.doi.org/10.1016/j.piutam.2011.04.027">https://dx.doi.org/10.1016/j.piutam.2011.04.027</a> </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="mocomainpage.html">Moco</a></li><li class="navelem"><a class="el" href="mocouserguide.html">Moco User Guide</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:16 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
